package com.yutou.nas.mybatis.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class MusicFavoritesExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public MusicFavoritesExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFavoriteidIsNull() {
            addCriterion("favoriteId is null");
            return (Criteria) this;
        }

        public Criteria andFavoriteidIsNotNull() {
            addCriterion("favoriteId is not null");
            return (Criteria) this;
        }

        public Criteria andFavoriteidEqualTo(Integer value) {
            addCriterion("favoriteId =", value, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidNotEqualTo(Integer value) {
            addCriterion("favoriteId <>", value, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidGreaterThan(Integer value) {
            addCriterion("favoriteId >", value, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidGreaterThanOrEqualTo(Integer value) {
            addCriterion("favoriteId >=", value, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidLessThan(Integer value) {
            addCriterion("favoriteId <", value, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidLessThanOrEqualTo(Integer value) {
            addCriterion("favoriteId <=", value, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidIn(List<Integer> values) {
            addCriterion("favoriteId in", values, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidNotIn(List<Integer> values) {
            addCriterion("favoriteId not in", values, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidBetween(Integer value1, Integer value2) {
            addCriterion("favoriteId between", value1, value2, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andFavoriteidNotBetween(Integer value1, Integer value2) {
            addCriterion("favoriteId not between", value1, value2, "favoriteid");
            return (Criteria) this;
        }

        public Criteria andMusisMd5IsNull() {
            addCriterion("musis_md5 is null");
            return (Criteria) this;
        }

        public Criteria andMusisMd5IsNotNull() {
            addCriterion("musis_md5 is not null");
            return (Criteria) this;
        }

        public Criteria andMusisMd5EqualTo(String value) {
            addCriterion("musis_md5 =", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5NotEqualTo(String value) {
            addCriterion("musis_md5 <>", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5GreaterThan(String value) {
            addCriterion("musis_md5 >", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5GreaterThanOrEqualTo(String value) {
            addCriterion("musis_md5 >=", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5LessThan(String value) {
            addCriterion("musis_md5 <", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5LessThanOrEqualTo(String value) {
            addCriterion("musis_md5 <=", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5Like(String value) {
            addCriterion("musis_md5 like", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5NotLike(String value) {
            addCriterion("musis_md5 not like", value, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5In(List<String> values) {
            addCriterion("musis_md5 in", values, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5NotIn(List<String> values) {
            addCriterion("musis_md5 not in", values, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5Between(String value1, String value2) {
            addCriterion("musis_md5 between", value1, value2, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andMusisMd5NotBetween(String value1, String value2) {
            addCriterion("musis_md5 not between", value1, value2, "musisMd5");
            return (Criteria) this;
        }

        public Criteria andSubTimeIsNull() {
            addCriterion("sub_time is null");
            return (Criteria) this;
        }

        public Criteria andSubTimeIsNotNull() {
            addCriterion("sub_time is not null");
            return (Criteria) this;
        }

        public Criteria andSubTimeEqualTo(Date value) {
            addCriterion("sub_time =", value, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeNotEqualTo(Date value) {
            addCriterion("sub_time <>", value, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeGreaterThan(Date value) {
            addCriterion("sub_time >", value, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("sub_time >=", value, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeLessThan(Date value) {
            addCriterion("sub_time <", value, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeLessThanOrEqualTo(Date value) {
            addCriterion("sub_time <=", value, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeIn(List<Date> values) {
            addCriterion("sub_time in", values, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeNotIn(List<Date> values) {
            addCriterion("sub_time not in", values, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeBetween(Date value1, Date value2) {
            addCriterion("sub_time between", value1, value2, "subTime");
            return (Criteria) this;
        }

        public Criteria andSubTimeNotBetween(Date value1, Date value2) {
            addCriterion("sub_time not between", value1, value2, "subTime");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}